The zxdg_positioner_v6 interface

## Macros

#define | ZXDG_POSITIONER_V6_DESTROY_SINCE_VERSION 1
#define | ZXDG_POSITIONER_V6_SET_SIZE_SINCE_VERSION 1
#define | ZXDG_POSITIONER_V6_SET_ANCHOR_RECT_SINCE_VERSION 1
#define | ZXDG_POSITIONER_V6_SET_ANCHOR_SINCE_VERSION 1
#define | ZXDG_POSITIONER_V6_SET_GRAVITY_SINCE_VERSION 1
#define | ZXDG_POSITIONER_V6_SET_CONSTRAINT_ADJUSTMENT_SINCE_VERSION 1
#define | ZXDG_POSITIONER_V6_SET_OFFSET_SINCE_VERSION 1

## Enumerations

enum

zxdg_positioner_v6_constraint_adjustment {
ZXDG_POSITIONER_V6_CONSTRAINT_ADJUSTMENT_NONE = 0,
ZXDG_POSITIONER_V6_CONSTRAINT_ADJUSTMENT_SLIDE_X = 1,
ZXDG_POSITIONER_V6_CONSTRAINT_ADJUSTMENT_SLIDE_Y = 2,
ZXDG_POSITIONER_V6_CONSTRAINT_ADJUSTMENT_FLIP_X = 4,
ZXDG_POSITIONER_V6_CONSTRAINT_ADJUSTMENT_FLIP_Y = 8,
ZXDG_POSITIONER_V6_CONSTRAINT_ADJUSTMENT_RESIZE_X = 16,
ZXDG_POSITIONER_V6_CONSTRAINT_ADJUSTMENT_RESIZE_Y = 32
}

## Functions

static void | zxdg_positioner_v6_set_user_data (struct zxdg_positioner_v6 *zxdg_positioner_v6, void *user_data)
static void * | zxdg_positioner_v6_get_user_data (struct zxdg_positioner_v6 *zxdg_positioner_v6)
static void | zxdg_positioner_v6_destroy (struct zxdg_positioner_v6 *zxdg_positioner_v6)
static void | zxdg_positioner_v6_set_size (struct zxdg_positioner_v6 *zxdg_positioner_v6, int32_t width, int32_t height)
static void | zxdg_positioner_v6_set_anchor_rect (struct zxdg_positioner_v6 *zxdg_positioner_v6, int32_t x, int32_t y, int32_t width, int32_t height)
static void | zxdg_positioner_v6_set_anchor (struct zxdg_positioner_v6 *zxdg_positioner_v6, uint32_t anchor)
static void | zxdg_positioner_v6_set_gravity (struct zxdg_positioner_v6 *zxdg_positioner_v6, uint32_t gravity)
static void | zxdg_positioner_v6_set_constraint_adjustment (struct zxdg_positioner_v6 *zxdg_positioner_v6, uint32_t constraint_adjustment)
static void | zxdg_positioner_v6_set_offset (struct zxdg_positioner_v6 *zxdg_positioner_v6, int32_t x, int32_t y)

## Detailed Description

The xdg_positioner provides a collection of rules for the placement of a child surface relative to a parent surface. Rules can be defined to ensure the child surface remains within the visible area's borders, and to specify how the child surface changes its position, such as sliding along an axis, or flipping around a rectangle. These positioner-created rules are constrained by the requirement that a child surface must intersect with or be at least partially adjacent to its parent surface.

See the various requests for details about possible rules.

At the time of the request, the compositor makes a copy of the rules specified by the xdg_positioner. Thus, after the request is complete the xdg_positioner object can be destroyed or reused; further changes to the object will have no effect on previous usages.

For an xdg_positioner object to be considered complete, it must have a non-zero size set by set_size, and a non-zero anchor rectangle set by set_anchor_rect. Passing an incomplete xdg_positioner object when positioning a surface raises an error.

## Macro Definition Documentation

## ZXDG_POSITIONER_V6_DESTROY_SINCE_VERSION

#define ZXDG_POSITIONER_V6_DESTROY_SINCE_VERSION 1

Definition at line 585 of file xdg-shell-unstable-v6-client-protocol.h.

## ZXDG_POSITIONER_V6_SET_ANCHOR_RECT_SINCE_VERSION

#define ZXDG_POSITIONER_V6_SET_ANCHOR_RECT_SINCE_VERSION 1

Definition at line 593 of file xdg-shell-unstable-v6-client-protocol.h.

## ZXDG_POSITIONER_V6_SET_ANCHOR_SINCE_VERSION

#define ZXDG_POSITIONER_V6_SET_ANCHOR_SINCE_VERSION 1

Definition at line 597 of file xdg-shell-unstable-v6-client-protocol.h.

## ZXDG_POSITIONER_V6_SET_CONSTRAINT_ADJUSTMENT_SINCE_VERSION

#define ZXDG_POSITIONER_V6_SET_CONSTRAINT_ADJUSTMENT_SINCE_VERSION 1

Definition at line 605 of file xdg-shell-unstable-v6-client-protocol.h.

## ZXDG_POSITIONER_V6_SET_GRAVITY_SINCE_VERSION

#define ZXDG_POSITIONER_V6_SET_GRAVITY_SINCE_VERSION 1

Definition at line 601 of file xdg-shell-unstable-v6-client-protocol.h.

## ZXDG_POSITIONER_V6_SET_OFFSET_SINCE_VERSION

#define ZXDG_POSITIONER_V6_SET_OFFSET_SINCE_VERSION 1

Definition at line 609 of file xdg-shell-unstable-v6-client-protocol.h.

## ZXDG_POSITIONER_V6_SET_SIZE_SINCE_VERSION

#define ZXDG_POSITIONER_V6_SET_SIZE_SINCE_VERSION 1

Definition at line 589 of file xdg-shell-unstable-v6-client-protocol.h.

## Enumeration Type Documentation

## zxdg_positioner_v6_constraint_adjustment

enum zxdg_positioner_v6_constraint_adjustment

vertically resize the surface

Resize the surface vertically so that it is completely unconstrained.

Enumerator
ZXDG_POSITIONER_V6_CONSTRAINT_ADJUSTMENT_NONE |
ZXDG_POSITIONER_V6_CONSTRAINT_ADJUSTMENT_SLIDE_X |
ZXDG_POSITIONER_V6_CONSTRAINT_ADJUSTMENT_SLIDE_Y |
ZXDG_POSITIONER_V6_CONSTRAINT_ADJUSTMENT_FLIP_X |
ZXDG_POSITIONER_V6_CONSTRAINT_ADJUSTMENT_FLIP_Y |
ZXDG_POSITIONER_V6_CONSTRAINT_ADJUSTMENT_RESIZE_X |
ZXDG_POSITIONER_V6_CONSTRAINT_ADJUSTMENT_RESIZE_Y |

Definition at line 562 of file xdg-shell-unstable-v6-client-protocol.h.

{
ZXDG_POSITIONER_V6_CONSTRAINT_ADJUSTMENT_NONE = 0,
ZXDG_POSITIONER_V6_CONSTRAINT_ADJUSTMENT_SLIDE_X = 1,
ZXDG_POSITIONER_V6_CONSTRAINT_ADJUSTMENT_SLIDE_Y = 2,
ZXDG_POSITIONER_V6_CONSTRAINT_ADJUSTMENT_FLIP_X = 4,
ZXDG_POSITIONER_V6_CONSTRAINT_ADJUSTMENT_FLIP_Y = 8,
ZXDG_POSITIONER_V6_CONSTRAINT_ADJUSTMENT_RESIZE_X = 16,
ZXDG_POSITIONER_V6_CONSTRAINT_ADJUSTMENT_RESIZE_Y = 32,
};
ZXDG_POSITIONER_V6_CONSTRAINT_ADJUSTMENT_NONE
Definition: xdg-shell-unstable-v6-client-protocol.h:563
ZXDG_POSITIONER_V6_CONSTRAINT_ADJUSTMENT_SLIDE_X
Definition: xdg-shell-unstable-v6-client-protocol.h:564
ZXDG_POSITIONER_V6_CONSTRAINT_ADJUSTMENT_SLIDE_Y
Definition: xdg-shell-unstable-v6-client-protocol.h:565
ZXDG_POSITIONER_V6_CONSTRAINT_ADJUSTMENT_RESIZE_X
Definition: xdg-shell-unstable-v6-client-protocol.h:568
ZXDG_POSITIONER_V6_CONSTRAINT_ADJUSTMENT_FLIP_Y
Definition: xdg-shell-unstable-v6-client-protocol.h:567
ZXDG_POSITIONER_V6_CONSTRAINT_ADJUSTMENT_RESIZE_Y
Definition: xdg-shell-unstable-v6-client-protocol.h:569
ZXDG_POSITIONER_V6_CONSTRAINT_ADJUSTMENT_FLIP_X
Definition: xdg-shell-unstable-v6-client-protocol.h:566

## Function Documentation

## zxdg_positioner_v6_destroy()

static void zxdg_positioner_v6_destroy | ( | struct zxdg_positioner_v6 * | zxdg_positioner_v6 | ) |

inline static

Notify the compositor that the xdg_positioner will no longer be used.

Definition at line 637 of file xdg-shell-unstable-v6-client-protocol.h.

References ZXDG_POSITIONER_V6_DESTROY.

{
wl_proxy_marshal((struct wl_proxy *) zxdg_positioner_v6,
ZXDG_POSITIONER_V6_DESTROY);
wl_proxy_destroy((struct wl_proxy *) zxdg_positioner_v6);
}
ZXDG_POSITIONER_V6_DESTROY
#define ZXDG_POSITIONER_V6_DESTROY
Definition: xdg-shell-unstable-v6-client-protocol.h:573

## zxdg_positioner_v6_get_user_data()

static void* zxdg_positioner_v6_get_user_data | ( | struct zxdg_positioner_v6 * | zxdg_positioner_v6 | ) |

inline static

Definition at line 620 of file xdg-shell-unstable-v6-client-protocol.h.

{
return wl_proxy_get_user_data((struct wl_proxy *) zxdg_positioner_v6);
}

## zxdg_positioner_v6_set_anchor()

static void zxdg_positioner_v6_set_anchor | ( | struct zxdg_positioner_v6 * | zxdg_positioner_v6,
|  | uint32_t | anchor
| ) |  |

inline static

Defines a set of edges for the anchor rectangle. These are used to derive an anchor point that the child surface will be positioned relative to. If two orthogonal edges are specified (e.g. 'top' and 'left'), then the anchor point will be the intersection of the edges (e.g. the top left position of the rectangle); otherwise, the derived anchor point will be centered on the specified edge, or in the center of the anchor rectangle if no edge is specified.

If two parallel anchor edges are specified (e.g. 'left' and 'right'), the invalid_input error is raised.

Definition at line 697 of file xdg-shell-unstable-v6-client-protocol.h.

References ZXDG_POSITIONER_V6_SET_ANCHOR.

{
wl_proxy_marshal((struct wl_proxy *) zxdg_positioner_v6,
ZXDG_POSITIONER_V6_SET_ANCHOR, anchor);
}
ZXDG_POSITIONER_V6_SET_ANCHOR
#define ZXDG_POSITIONER_V6_SET_ANCHOR
Definition: xdg-shell-unstable-v6-client-protocol.h:576

## zxdg_positioner_v6_set_anchor_rect()

static void zxdg_positioner_v6_set_anchor_rect | ( | struct zxdg_positioner_v6 * | zxdg_positioner_v6,
|  | int32_t | x,
|  | int32_t | y,
|  | int32_t | width,
|  | int32_t | height
| ) |  |

inline static

Specify the anchor rectangle within the parent surface that the child surface will be placed relative to. The rectangle is relative to the window geometry as defined by xdg_surface.set_window_geometry of the parent surface. The rectangle must be at least 1x1 large.

When the xdg_positioner object is used to position a child surface, the anchor rectangle may not extend outside the window geometry of the positioned child's parent surface.

If a zero or negative size is set the invalid_input error is raised.

Definition at line 676 of file xdg-shell-unstable-v6-client-protocol.h.

References ZXDG_POSITIONER_V6_SET_ANCHOR_RECT.

{
wl_proxy_marshal((struct wl_proxy *) zxdg_positioner_v6,
ZXDG_POSITIONER_V6_SET_ANCHOR_RECT, x, y, width, height);
}
x
GLint GLint GLint GLint GLint x
Definition: SDL_opengl.h:1574
ZXDG_POSITIONER_V6_SET_ANCHOR_RECT
#define ZXDG_POSITIONER_V6_SET_ANCHOR_RECT
Definition: xdg-shell-unstable-v6-client-protocol.h:575
width
GLint GLint GLsizei width
Definition: SDL_opengl.h:1572
y
GLint GLint GLint GLint GLint GLint y
Definition: SDL_opengl.h:1574
height
GLint GLint GLsizei GLsizei height
Definition: SDL_opengl.h:1572

## zxdg_positioner_v6_set_constraint_adjustment()

static void zxdg_positioner_v6_set_constraint_adjustment | ( | struct zxdg_positioner_v6 * | zxdg_positioner_v6,
|  | uint32_t | constraint_adjustment
| ) |  |

inline static

Specify how the window should be positioned if the originally intended position caused the surface to be constrained, meaning at least partially outside positioning boundaries set by the compositor. The adjustment is set by constructing a bitmask describing the adjustment to be made when the surface is constrained on that axis.

If no bit for one axis is set, the compositor will assume that the child surface should not change its position on that axis when constrained.

If more than one bit for one axis is set, the order of how adjustments are applied is specified in the corresponding adjustment descriptions.

The default adjustment is none.

Definition at line 741 of file xdg-shell-unstable-v6-client-protocol.h.

References ZXDG_POSITIONER_V6_SET_CONSTRAINT_ADJUSTMENT.

{
wl_proxy_marshal((struct wl_proxy *) zxdg_positioner_v6,
ZXDG_POSITIONER_V6_SET_CONSTRAINT_ADJUSTMENT, constraint_adjustment);
}
ZXDG_POSITIONER_V6_SET_CONSTRAINT_ADJUSTMENT
#define ZXDG_POSITIONER_V6_SET_CONSTRAINT_ADJUSTMENT
Definition: xdg-shell-unstable-v6-client-protocol.h:578

## zxdg_positioner_v6_set_gravity()

static void zxdg_positioner_v6_set_gravity | ( | struct zxdg_positioner_v6 * | zxdg_positioner_v6,
|  | uint32_t | gravity
| ) |  |

inline static

Defines in what direction a surface should be positioned, relative to the anchor point of the parent surface. If two orthogonal gravities are specified (e.g. 'bottom' and 'right'), then the child surface will be placed in the specified direction; otherwise, the child surface will be centered over the anchor point on any axis that had no gravity specified.

If two parallel gravities are specified (e.g. 'left' and 'right'), the invalid_input error is raised.

Definition at line 717 of file xdg-shell-unstable-v6-client-protocol.h.

References ZXDG_POSITIONER_V6_SET_GRAVITY.

{
wl_proxy_marshal((struct wl_proxy *) zxdg_positioner_v6,
ZXDG_POSITIONER_V6_SET_GRAVITY, gravity);
}
ZXDG_POSITIONER_V6_SET_GRAVITY
#define ZXDG_POSITIONER_V6_SET_GRAVITY
Definition: xdg-shell-unstable-v6-client-protocol.h:577

## zxdg_positioner_v6_set_offset()

static void zxdg_positioner_v6_set_offset | ( | struct zxdg_positioner_v6 * | zxdg_positioner_v6,
|  | int32_t | x,
|  | int32_t | y
| ) |  |

inline static

Specify the surface position offset relative to the position of the anchor on the anchor rectangle and the anchor on the surface. For example if the anchor of the anchor rectangle is at (x, y), the surface has the gravity bottom|right, and the offset is (ox, oy), the calculated surface position will be (x + ox, y + oy). The offset position of the surface is the one used for constraint testing. See set_constraint_adjustment.

An example use case is placing a popup menu on top of a user interface element, while aligning the user interface element of the parent surface with some user interface element placed somewhere in the popup surface.

Definition at line 763 of file xdg-shell-unstable-v6-client-protocol.h.

References ZXDG_POSITIONER_V6_SET_OFFSET.

{
wl_proxy_marshal((struct wl_proxy *) zxdg_positioner_v6,
ZXDG_POSITIONER_V6_SET_OFFSET, x, y);
}
x
GLint GLint GLint GLint GLint x
Definition: SDL_opengl.h:1574
ZXDG_POSITIONER_V6_SET_OFFSET
#define ZXDG_POSITIONER_V6_SET_OFFSET
Definition: xdg-shell-unstable-v6-client-protocol.h:579
y
GLint GLint GLint GLint GLint GLint y
Definition: SDL_opengl.h:1574

## zxdg_positioner_v6_set_size()

static void zxdg_positioner_v6_set_size | ( | struct zxdg_positioner_v6 * | zxdg_positioner_v6,
|  | int32_t | width,
|  | int32_t | height
| ) |  |

inline static

Set the size of the surface that is to be positioned with the positioner object. The size is in surface-local coordinates and corresponds to the window geometry. See xdg_surface.set_window_geometry.

If a zero or negative size is set the invalid_input error is raised.

Definition at line 655 of file xdg-shell-unstable-v6-client-protocol.h.

References ZXDG_POSITIONER_V6_SET_SIZE.

{
wl_proxy_marshal((struct wl_proxy *) zxdg_positioner_v6,
ZXDG_POSITIONER_V6_SET_SIZE, width, height);
}
width
GLint GLint GLsizei width
Definition: SDL_opengl.h:1572
height
GLint GLint GLsizei GLsizei height
Definition: SDL_opengl.h:1572
ZXDG_POSITIONER_V6_SET_SIZE
#define ZXDG_POSITIONER_V6_SET_SIZE
Definition: xdg-shell-unstable-v6-client-protocol.h:574

## zxdg_positioner_v6_set_user_data()

static void zxdg_positioner_v6_set_user_data | ( | struct zxdg_positioner_v6 * | zxdg_positioner_v6,
|  | void * | user_data
| ) |  |

inline static

Definition at line 613 of file xdg-shell-unstable-v6-client-protocol.h.

{
wl_proxy_set_user_data((struct wl_proxy *) zxdg_positioner_v6, user_data);
}